#pragma once
#include <vector>
#include <string>
#include "vec3.h"


typedef Vec3 Pixel;

class Picture
{
public:
    std::vector<Pixel> pixels;
    const int res_x, res_y;

    Picture(int x, int y);

    void fill_with_checkerboard();
    void print_to_screen()const;

    void save_as_pnm(const std::string &filename)const;

    // accessors to pixels...

    // setter
    // "pic.pixel(i,j) = pix;"   è come dire "pic.set_pixel(i,i, pix);"
    Pixel& pixel(int x, int y){
        return pixels[y*res_x+x];
    }

    // getter
    // "Pixel pix = pic.pixel(i,j)"   è come dire "Pixel pix = pic.get_pixel(i,i, P);"
    Pixel pixel(int x, int y) const {
        return pixels[y*res_x+x];
    }

    
};

